<?php
function computePressure($tt, $pp)
{
  $ac1 = 6952;
  $ac2 = -1145;
  $ac3 = -14756;
  $ac4 = 32889;
  $ac5 = 24665;
  $ac6 = 17467;
  $b1 = 5498;
  $b2 = 61;
  $mb = -32768;
  $mc = -11075;
  $md = 2432;

  $x1 = floor(($tt - $ac6)*$ac5 / 32768);
  $x2 = floor($mc*2048 / ($x1 + $md));
  $b5 = $x1 + $x2;
  //$t = floor(($b5 + 8) / 16);

  $b6 = $b5 - 4000;
  $x1 = floor($b2*floor($b6*$b6/4096) / 2048);
  $x2 = floor($ac2 * $b6 / 2048);
  $x3 = $x1 + $x2;

  $b3 = floor(($ac1*4 + $x3 + 2) / 4);
  $x1 = floor($ac3 * $b6 / 8192);
  $x2 = floor($b1*floor($b6*$b6/4096)/65536);
  $x3 = floor(($x1 + $x2 + 2) / 4);

  $b4 = floor($ac4*($x3 + 32768) / 32768);
  $b7 = ($pp - $b3)*50000;
  if ($b7 < 0x80000000)
    $p = floor(($b7 * 2) / $b4);
  else
    $p = floor($b7/$b4) * 2;

  $x1 = floor(($p*$p) / 65536);
  $x2 = floor(($x1 * 3038) / 65536);
  $x3 = floor((-7357*$p) / 65536);
  $p = $p + floor(($x2 + $x3 + 3791) / 16);
  $p = round($p * 0.0075) + 13;
  return("{$p} mmHg");
}

$s = "";
$ut = 0;
$up = 0;
if (isset($_GET['temp']))
{
  $n = "0x{$_GET['temp']}";
  $n = round(175.72 * $n / 65536 - 46.85);
  $s .= sprintf("%d °C\t", $n);
}
if (isset($_GET['humi']))
{
  $n = "0x{$_GET['humi']}";
  $n = round(125 * $n / 65536 - 6);
  $s .= sprintf("%d", $n) . " %\t";
}
if (isset($_GET['temp2']))
  $ut = "0x{$_GET['temp2']}";
if (isset($_GET['press']))
  $up = "0x{$_GET['press']}";
if ($ut + $up)
  $s .= computePressure($ut, $up);
$t = time();		// timestamp
$s .= "\t{$t}\n";  

$file = 'sensors.dat';
file_put_contents($file, $s, FILE_APPEND | LOCK_EX);

//header("Access-Control-Allow-Origin: *\n");
header("Content-Type: text/html\n\n");
print($t); 
?>
